/* =========================================================================

InDesign ExtendScript

NAME: InBrush.js
VERSION: 1.1

AUTHOR: Vitaly Batushev
DATE  : 03.04.2005

DESCRIPTION:
  ,        
(   ).
     0%,      
 .


SUPPORT: http://indesign.rudtp.ru
E-MAIL: vbatushev@indesign.rudtp.ru

============================================================================ */
with (app) {
	if (documents.length < 1) {
		alert("No open documents");
		exit();
	}
	var myDoc = activeDocument;
	
	var myDlg = dialogs.add({name: "InBrush v.1.1"});
	
	var mySwatchList = new Array(app.activeDocument.swatches.length);
	for(i = 0; i < app.activeDocument.swatches.length; i++){
		mySwatch = app.activeDocument.swatches.item(i);
		mySwatchList[i] = mySwatch.name;
	}
	var arrValues = new Array('0', '10', '20', '30', '40', '50', '60', '70', '80', '90', '100');
	
	with (myDlg) {
		with (dialogColumns.add()) {
			with (dialogRows.add()) {
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
				with (dialogRows.add()) {
				staticTexts.add({staticLabel:'Find', minWidth:58});
				}
				with (dialogRows.add()) {
				staticTexts.add({staticLabel:'Color:'});
				var myFindColor = dropdowns.add({stringList:mySwatchList, selectedIndex:0});
				}
				with (dialogRows.add()) {
				staticTexts.add({staticLabel:'Tint:', minWidth:32});
				var myFindTint = percentComboboxes.add({editValue:0, stringList:arrValues, minimumValue:0, maximumValue:100});
				}
				}
				with (dialogColumns.add()) {
				with (dialogRows.add()) {
				staticTexts.add({staticLabel:'Change', minWidth:78});
				}
				with (dialogRows.add()) {
				staticTexts.add({staticLabel:'Color:'});
				var myChangeColor = dropdowns.add({stringList:mySwatchList, selectedIndex:0});
				}
				with (dialogRows.add()) {
				staticTexts.add({staticLabel:'Tint:', minWidth:32});
				var myChangeTint = percentComboboxes.add({editValue:0, stringList:arrValues, minimumValue:0, maximumValue:100});
				}
				}
			}
			}
			with (dialogRows.add()) {
				with (dialogColumns.add()) {
				var AllEnable = enablingGroups.add({staticLabel:'Work with only:'});
				with (AllEnable) {
				with (dialogColumns.add()) {
				with (dialogRows.add()) {
				var chkGraphicLines = checkboxControls.add({checkedState:true, staticLabel:'Graphic Lines'});
				var chkOvals = checkboxControls.add({checkedState:true, staticLabel:'Ovals'});
				var chkPolygons = checkboxControls.add({checkedState:true, staticLabel:'Polygons'});
				var chkRectangles = checkboxControls.add({checkedState:true, staticLabel:'Rectangles'});
				}
				with (dialogRows.add()) {
				var chkTextFrames = checkboxControls.add({checkedState:true, staticLabel:'Text Frames'});
				var chkTexts = checkboxControls.add({checkedState:true, staticLabel:'Texts'});
				var chkTexts = checkboxControls.add({checkedState:true, staticLabel:'Tables'});
				}}
				}
				with (dialogColumns.add()) {
					staticTexts.add({staticLabel:'', minWidth:50});
					staticTexts.add({staticLabel:'Vitaly Batushev  2005', minWidth:50});
					staticTexts.add({staticLabel:'http://indesign.rudtp.ru', minWidth:50});
				}
			}
			}
		}
	}
	
	result = myDlg.show();
	
	if (result == false) {
		myDlg.destroy();
		exit();
	}

	for (ig = 0; ig < myDoc.groups.length; ig++) {
		ReBrush(myDoc.groups.item(ig), myDoc.swatches.item(myFindColor.selectedIndex),
		myDoc.swatches.item(myChangeColor.selectedIndex), myFindTint.editValue, myChangeTint.editValue,
		AllEnable.checkedState, chkGraphicLines.checkedState, chkOvals.checkedState, chkPolygons.checkedState,
		chkRectangles.checkedState, chkTextFrames.checkedState, chkTexts.checkedState, chkTexts.checkedState);
	}	
		res = ReBrush(myDoc, myDoc.swatches.item(myFindColor.selectedIndex),
		myDoc.swatches.item(myChangeColor.selectedIndex), myFindTint.editValue, myChangeTint.editValue,
		AllEnable.checkedState, chkGraphicLines.checkedState, chkOvals.checkedState, chkPolygons.checkedState,
		chkRectangles.checkedState, chkTextFrames.checkedState, chkTexts.checkedState, chkTexts.checkedState);
	if (res == true) {
		alert('Swatch ' + myDoc.swatches.item(myFindColor.selectedIndex).name + ' (Tint: ' + myFindTint.editValue + '%)\r rebrushed to swatch ' +
		myDoc.swatches.item(myChangeColor.selectedIndex).name + ' (Tint: ' + myChangeTint.editValue + '%)');
		exit();
	}
}

function ReBrush(myDoc, myFindColor, myChangeColor, myFindTint, myChangeTint, EnableAll,
EnableGraphicLines, EnableOvals, EnablePolygons, EnableRectangles, EnableTextFrames,
EnableTexts, EnableTables) {

if (myFindTint == '100') {
	myFindTint = -1;
	myTextFindTint = 100;
} else {
	myTextFindTint = myFindTint;
}

if (EnableAll == true) {
	var myItems = new Array(myDoc.graphicLines, myDoc.ovals, myDoc.polygons, myDoc.rectangles, myDoc.textFrames);
} else {
	var myItems = new Array;
	if (EnableGraphicLines == true) {
		if (myDoc.graphicLines.length > 0) {
			myItems.push(myDoc.graphicLines);
		}
	}
	if (EnableOvals == true) { 
		if (myDoc.ovals.length > 0) { myItems.push(myDoc.ovals); }
	}
	if (EnablePolygons == true) { 
		if (myDoc.polygons.length > 0) { myItems.push(myDoc.polygons); }
	}
	if (EnableRectangles == true) {
		if (myDoc.rectangles.length > 0) { myItems.push(myDoc.rectangles); }
	}
	if (EnableTextFrames == true) { 
			if (myDoc.textFrames.length > 0) { myItems.push(myDoc.textFrames); }
	}
}

if (myItems.length > 0) {	
for (mi = 0; mi < myItems.length; mi++) {
	for (i = 0; i < myItems[mi].length; i++) {
		myPageItem = myItems[mi].item(i);
		if (myFindTint != 0) {
			if (myPageItem.fillTint == myFindTint) {
				if (myPageItem.fillColor == myFindColor) {
					myPageItem.fillColor = myChangeColor;
					if (myChangeTint > 0) { myPageItem.fillTint = myChangeTint; }
				}
			}
			if (myPageItem.strokeTint == myFindTint) {
				if (myPageItem.strokeFill == myFindColor) {
					myPageItem.strokeFill = myChangeColor;
					if (myChangeTint > 0) { myPageItem.strokeTint = myChangeTint; }
				}
			}
		} else {
			if (myPageItem.fillColor == myFindColor) {
				myPageItem.fillColor = myChangeColor;
				if (myChangeTint > 0) { myPageItem.fillTint = myChangeTint; }
			}
			if (myPageItem.strokeColor == myFindColor) {
				myPageItem.strokeColor = myChangeColor;
				if (myChangeTint > 0) { myPageItem.strokeTint = myChangeTint; }
			}
		}
	}
}
}
	
if (myDoc.constructor.name != 'Group') {
if (EnableTexts == true | EnableAll == true) {
	app.findPreferences = undefined;
	app.changePreferences = undefined;

	app.findPreferences.fillColor = myFindColor;
	if (myTextFindTint > 0) { app.findPreferences.fillTint = myTextFindTint; } 
	app.changePreferences.fillColor = myChangeColor;
	if (myChangeTint > 0) { app.changePreferences.fillTint = myChangeTint; }
	myDoc.search('', false, false, '');

	app.findPreferences = undefined;
	app.changePreferences = undefined;

	app.findPreferences.strokeColor = myFindColor;
	if (myTextFindTint > 0) { app.findPreferences.strokeTint = myTextFindTint; }
	app.changePreferences.strokeColor = myChangeColor;
	if (myChangeTint > 0) { app.changePreferences.strokeTint = myChangeTint; }
	myDoc.search('', false, false, '');

	app.findPreferences = undefined;
	app.changePreferences = undefined;
}	

if (EnableTables == true | EnableAll == true) {
	for (i = 0; i < myDoc.stories.length; i++) {
		var myStory = myDoc.stories.item(i);
		for (j = 0; j < myStory.tables.length; j++) {
			var myTable = myStory.tables.item(j);
			for (c = 0; c < myTable.cells.length; c++) {
				if (myFindTint != 0) {
					if (myTable.cells.item(c).fillTint == myFindTint) {
						if (myTable.cells.item(c).fillColor == myFindColor) {
							myTable.cells.item(c).fillColor = myChangeColor;
							if (myChangeTint > 0) { myTable.cells.item(c).fillTint = myChangeTint; }
						}
					}
					if (myTable.cells.item(c).strokeTint == myFindTint) {
						if (myTable.cells.item(c).strokeColor == myFindColor) {
							myTable.cells.item(c).strokeColor = myChangeColor;
							if (myChangeTint > 0) { myTable.cells.item(c).strokeTint = myChangeTint; }
						}
					}
				} else {
					if (myTable.cells.item(c).fillColor == myFindColor) {
						myTable.cells.item(c).fillColor = myChangeColor;
						if (myChangeTint > 0) { myTable.cells.item(c).fillTint = myChangeTint; }
					}
					if (myTable.cells.item(c).strokeColor == myFindColor) {
						myTable.cells.item(c).strokeColor = myChangeColor;
						if (myChangeTint > 0) { myTable.cells.item(c).strokeTint = myChangeTint; }
					}
				}
			}
		}
	}
}
}
return true;
}